drm/nouveau: fix kernel-doc comments
[drm/drm-misc.git] / tools / lib / bpf / Makefile
blob857a5f7b413d6dc4cbe7bc4167496674dd08d875
1 # SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause)
2 # Most of this file is copied from tools/lib/traceevent/Makefile
4 RM ?= rm
5 srctree := $(realpath $(srctree))
7 VERSION_SCRIPT := libbpf.map
8 LIBBPF_VERSION := $(shell \
9 grep -oE '^LIBBPF_([0-9.]+)' $(VERSION_SCRIPT) | \
10 sort -rV | head -n1 | cut -d'_' -f2)
11 LIBBPF_MAJOR_VERSION := $(word 1,$(subst ., ,$(LIBBPF_VERSION)))
12 LIBBPF_MINOR_VERSION := $(word 2,$(subst ., ,$(LIBBPF_VERSION)))
14 MAKEFLAGS += --no-print-directory
16 # This will work when bpf is built in tools env. where srctree
17 # isn't set and when invoked from selftests build, where srctree
18 # is a ".". building_out_of_srctree is undefined for in srctree
19 # builds
20 ifndef building_out_of_srctree
21 srctree := $(patsubst %/,%,$(dir $(CURDIR)))
22 srctree := $(patsubst %/,%,$(dir $(srctree)))
23 srctree := $(patsubst %/,%,$(dir $(srctree)))
24 #$(info Determined 'srctree' to be $(srctree))
25 endif
27 INSTALL = install
29 # Use DESTDIR for installing into a different root directory.
30 # This is useful for building a package. The program will be
31 # installed in this directory as if it was the root directory.
32 # Then the build tool can move it later.
33 DESTDIR ?=
34 DESTDIR_SQ = '$(subst ','\'',$(DESTDIR))'
36 include $(srctree)/tools/scripts/Makefile.arch
38 ifeq ($(LP64), 1)
39 libdir_relative = lib64
40 else
41 libdir_relative = lib
42 endif
44 prefix ?= /usr/local
45 libdir = $(prefix)/$(libdir_relative)
46 man_dir = $(prefix)/share/man
47 man_dir_SQ = '$(subst ','\'',$(man_dir))'
49 export man_dir man_dir_SQ INSTALL
50 export DESTDIR DESTDIR_SQ
52 include $(srctree)/tools/scripts/Makefile.include
54 # copy a bit from Linux kbuild
56 ifeq ("$(origin V)", "command line")
57 VERBOSE = $(V)
58 endif
59 ifndef VERBOSE
60 VERBOSE = 0
61 endif
63 INCLUDES = -I$(or $(OUTPUT),.) \
64 -I$(srctree)/tools/include -I$(srctree)/tools/include/uapi \
65 -I$(srctree)/tools/arch/$(SRCARCH)/include
67 export prefix libdir src obj
69 # Shell quotes
70 libdir_SQ = $(subst ','\'',$(libdir))
71 libdir_relative_SQ = $(subst ','\'',$(libdir_relative))
73 OBJ = $@
74 N =
76 LIB_TARGET = libbpf.a libbpf.so.$(LIBBPF_VERSION)
77 LIB_FILE = libbpf.a libbpf.so*
78 PC_FILE = libbpf.pc
80 # Set compile option CFLAGS
81 ifdef EXTRA_CFLAGS
82 CFLAGS := $(EXTRA_CFLAGS)
83 else
84 CFLAGS := -g -O2
85 endif
87 # Append required CFLAGS
88 override CFLAGS += -std=gnu89
89 override CFLAGS += $(EXTRA_WARNINGS) -Wno-switch-enum
90 override CFLAGS += -Werror -Wall
91 override CFLAGS += $(INCLUDES)
92 override CFLAGS += -fvisibility=hidden
93 override CFLAGS += -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
94 override CFLAGS += $(CLANG_CROSS_FLAGS)
96 # flags specific for shared library
97 SHLIB_FLAGS := -DSHARED -fPIC
99 ifeq ($(VERBOSE),1)
101 else
102 Q = @
103 endif
105 # Disable command line variables (CFLAGS) override from top
106 # level Makefile (perf), otherwise build Makefile will get
107 # the same command line setup.
108 MAKEOVERRIDES=
110 all:
112 OUTPUT ?= ./
113 OUTPUT := $(abspath $(OUTPUT))/
114 export srctree OUTPUT CC LD CFLAGS V
115 include $(srctree)/tools/build/Makefile.include
117 SHARED_OBJDIR := $(OUTPUT)sharedobjs/
118 STATIC_OBJDIR := $(OUTPUT)staticobjs/
119 BPF_IN_SHARED := $(SHARED_OBJDIR)libbpf-in.o
120 BPF_IN_STATIC := $(STATIC_OBJDIR)libbpf-in.o
121 BPF_HELPER_DEFS := $(OUTPUT)bpf_helper_defs.h
122 BPF_GENERATED := $(BPF_HELPER_DEFS)
124 LIB_TARGET := $(addprefix $(OUTPUT),$(LIB_TARGET))
125 LIB_FILE := $(addprefix $(OUTPUT),$(LIB_FILE))
126 PC_FILE := $(addprefix $(OUTPUT),$(PC_FILE))
128 TAGS_PROG := $(if $(shell which etags 2>/dev/null),etags,ctags)
130 GLOBAL_SYM_COUNT = $(shell readelf -s --wide $(BPF_IN_SHARED) | \
131 cut -d "@" -f1 | sed 's/_v[0-9]_[0-9]_[0-9].*//' | \
132 sed 's/\[.*\]//' | \
133 awk '/GLOBAL/ && /DEFAULT/ && !/UND|ABS/ {print $$NF}' | \
134 sort -u | wc -l)
135 VERSIONED_SYM_COUNT = $(shell readelf --dyn-syms --wide $(OUTPUT)libbpf.so | \
136 sed 's/\[.*\]//' | \
137 awk '/GLOBAL/ && /DEFAULT/ && !/UND|ABS/ {print $$NF}' | \
138 grep -Eo '[^ ]+@LIBBPF_' | cut -d@ -f1 | sort -u | wc -l)
140 CMD_TARGETS = $(LIB_TARGET) $(PC_FILE)
142 all: fixdep
143 $(Q)$(MAKE) all_cmd
145 all_cmd: $(CMD_TARGETS) check
147 $(SHARED_OBJDIR) $(STATIC_OBJDIR):
148 $(Q)mkdir -p $@
150 $(BPF_IN_SHARED): force $(BPF_GENERATED) | $(SHARED_OBJDIR)
151 @(test -f ../../include/uapi/linux/bpf.h -a -f ../../../include/uapi/linux/bpf.h && ( \
152 (diff -B ../../include/uapi/linux/bpf.h ../../../include/uapi/linux/bpf.h >/dev/null) || \
153 echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/bpf.h' differs from latest version at 'include/uapi/linux/bpf.h'" >&2 )) || true
154 @(test -f ../../include/uapi/linux/bpf_common.h -a -f ../../../include/uapi/linux/bpf_common.h && ( \
155 (diff -B ../../include/uapi/linux/bpf_common.h ../../../include/uapi/linux/bpf_common.h >/dev/null) || \
156 echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/bpf_common.h' differs from latest version at 'include/uapi/linux/bpf_common.h'" >&2 )) || true
157 @(test -f ../../include/uapi/linux/if_xdp.h -a -f ../../../include/uapi/linux/if_xdp.h && ( \
158 (diff -B ../../include/uapi/linux/if_xdp.h ../../../include/uapi/linux/if_xdp.h >/dev/null) || \
159 echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/if_xdp.h' differs from latest version at 'include/uapi/linux/if_xdp.h'" >&2 )) || true
160 $(SILENT_MAKE) -C $(srctree)/tools/build CFLAGS= LDFLAGS= OUTPUT=$(SHARED_OBJDIR) $(SHARED_OBJDIR)fixdep
161 $(Q)$(MAKE) $(build)=libbpf OUTPUT=$(SHARED_OBJDIR) CFLAGS="$(CFLAGS) $(SHLIB_FLAGS)"
163 $(BPF_IN_STATIC): force $(BPF_GENERATED) | $(STATIC_OBJDIR)
164 $(SILENT_MAKE) -C $(srctree)/tools/build CFLAGS= LDFLAGS= OUTPUT=$(STATIC_OBJDIR) $(STATIC_OBJDIR)fixdep
165 $(Q)$(MAKE) $(build)=libbpf OUTPUT=$(STATIC_OBJDIR)
167 $(BPF_HELPER_DEFS): $(srctree)/tools/include/uapi/linux/bpf.h
168 $(QUIET_GEN)$(srctree)/scripts/bpf_doc.py --header \
169 --file $(srctree)/tools/include/uapi/linux/bpf.h > $(BPF_HELPER_DEFS)
171 $(OUTPUT)libbpf.so: $(OUTPUT)libbpf.so.$(LIBBPF_VERSION)
173 $(OUTPUT)libbpf.so.$(LIBBPF_VERSION): $(BPF_IN_SHARED) $(VERSION_SCRIPT)
174 $(QUIET_LINK)$(CC) $(CFLAGS) $(LDFLAGS) \
175 --shared -Wl,-soname,libbpf.so.$(LIBBPF_MAJOR_VERSION) \
176 -Wl,--version-script=$(VERSION_SCRIPT) $< -lelf -lz -o $@
177 @ln -sf $(@F) $(OUTPUT)libbpf.so
178 @ln -sf $(@F) $(OUTPUT)libbpf.so.$(LIBBPF_MAJOR_VERSION)
180 $(OUTPUT)libbpf.a: $(BPF_IN_STATIC)
181 $(QUIET_LINK)$(RM) -f $@; $(AR) rcs $@ $^
183 $(OUTPUT)libbpf.pc:
184 $(QUIET_GEN)sed -e "s|@PREFIX@|$(prefix)|" \
185 -e "s|@LIBDIR@|$(libdir_SQ)|" \
186 -e "s|@VERSION@|$(LIBBPF_VERSION)|" \
187 < libbpf.pc.template > $@
189 check: check_abi check_version
191 check_abi: $(OUTPUT)libbpf.so $(VERSION_SCRIPT)
192 @if [ "$(GLOBAL_SYM_COUNT)" != "$(VERSIONED_SYM_COUNT)" ]; then \
193 echo "Warning: Num of global symbols in $(BPF_IN_SHARED)" \
194 "($(GLOBAL_SYM_COUNT)) does NOT match with num of" \
195 "versioned symbols in $^ ($(VERSIONED_SYM_COUNT))." \
196 "Please make sure all LIBBPF_API symbols are" \
197 "versioned in $(VERSION_SCRIPT)." >&2; \
198 readelf -s --wide $(BPF_IN_SHARED) | \
199 cut -d "@" -f1 | sed 's/_v[0-9]_[0-9]_[0-9].*//' | \
200 sed 's/\[.*\]//' | \
201 awk '/GLOBAL/ && /DEFAULT/ && !/UND/ {print $$NF}'| \
202 sort -u > $(OUTPUT)libbpf_global_syms.tmp; \
203 readelf --dyn-syms --wide $(OUTPUT)libbpf.so | \
204 sed 's/\[.*\]//' | \
205 awk '/GLOBAL/ && /DEFAULT/ && !/UND|ABS/ {print $$NF}'| \
206 grep -Eo '[^ ]+@LIBBPF_' | cut -d@ -f1 | \
207 sort -u > $(OUTPUT)libbpf_versioned_syms.tmp; \
208 diff -u $(OUTPUT)libbpf_global_syms.tmp \
209 $(OUTPUT)libbpf_versioned_syms.tmp; \
210 rm $(OUTPUT)libbpf_global_syms.tmp \
211 $(OUTPUT)libbpf_versioned_syms.tmp; \
212 exit 1; \
215 HDR_MAJ_VERSION := $(shell grep -oE '^$(pound)define LIBBPF_MAJOR_VERSION ([0-9]+)$$' libbpf_version.h | cut -d' ' -f3)
216 HDR_MIN_VERSION := $(shell grep -oE '^$(pound)define LIBBPF_MINOR_VERSION ([0-9]+)$$' libbpf_version.h | cut -d' ' -f3)
218 check_version: $(VERSION_SCRIPT) libbpf_version.h
219 @if [ "$(HDR_MAJ_VERSION)" != "$(LIBBPF_MAJOR_VERSION)" ]; then \
220 echo "Error: libbpf major version mismatch detected: " \
221 "'$(HDR_MAJ_VERSION)' != '$(LIBBPF_MAJOR_VERSION)'" >&2; \
222 exit 1; \
224 @if [ "$(HDR_MIN_VERSION)" != "$(LIBBPF_MINOR_VERSION)" ]; then \
225 echo "Error: libbpf minor version mismatch detected: " \
226 "'$(HDR_MIN_VERSION)' != '$(LIBBPF_MINOR_VERSION)'" >&2; \
227 exit 1; \
230 define do_install_mkdir
231 if [ ! -d '$(DESTDIR_SQ)$1' ]; then \
232 $(INSTALL) -d -m 755 '$(DESTDIR_SQ)$1'; \
234 endef
236 define do_install
237 if [ ! -d '$(DESTDIR_SQ)$2' ]; then \
238 $(INSTALL) -d -m 755 '$(DESTDIR_SQ)$2'; \
239 fi; \
240 $(INSTALL) $(if $3,-m $3,) $1 '$(DESTDIR_SQ)$2'
241 endef
243 install_lib: all_cmd
244 $(call QUIET_INSTALL, $(LIB_TARGET)) \
245 $(call do_install_mkdir,$(libdir_SQ)); \
246 cp -fpR $(LIB_FILE) $(DESTDIR)$(libdir_SQ)
248 SRC_HDRS := bpf.h libbpf.h btf.h libbpf_common.h libbpf_legacy.h \
249 bpf_helpers.h bpf_tracing.h bpf_endian.h bpf_core_read.h \
250 skel_internal.h libbpf_version.h usdt.bpf.h
251 GEN_HDRS := $(BPF_GENERATED)
253 INSTALL_PFX := $(DESTDIR)$(prefix)/include/bpf
254 INSTALL_SRC_HDRS := $(addprefix $(INSTALL_PFX)/, $(SRC_HDRS))
255 INSTALL_GEN_HDRS := $(addprefix $(INSTALL_PFX)/, $(notdir $(GEN_HDRS)))
257 $(INSTALL_SRC_HDRS): $(INSTALL_PFX)/%.h: %.h
258 $(call QUIET_INSTALL, $@) \
259 $(call do_install,$<,$(prefix)/include/bpf,644)
261 $(INSTALL_GEN_HDRS): $(INSTALL_PFX)/%.h: $(OUTPUT)%.h
262 $(call QUIET_INSTALL, $@) \
263 $(call do_install,$<,$(prefix)/include/bpf,644)
265 install_headers: $(BPF_GENERATED) $(INSTALL_SRC_HDRS) $(INSTALL_GEN_HDRS)
266 $(call QUIET_INSTALL, libbpf_headers)
268 install_pkgconfig: $(PC_FILE)
269 $(call QUIET_INSTALL, $(PC_FILE)) \
270 $(call do_install,$(PC_FILE),$(libdir_SQ)/pkgconfig,644)
272 install: install_lib install_pkgconfig install_headers
274 clean: fixdep-clean
275 $(call QUIET_CLEAN, libbpf) $(RM) -rf $(CMD_TARGETS) \
276 *~ .*.d .*.cmd LIBBPF-CFLAGS $(BPF_GENERATED) \
277 $(SHARED_OBJDIR) $(STATIC_OBJDIR) \
278 $(addprefix $(OUTPUT), \
279 *.o *.a *.so *.so.$(LIBBPF_MAJOR_VERSION) *.pc)
281 PHONY += force cscope tags check check_abi check_version
282 force:
284 cscope:
285 ls *.c *.h > cscope.files
286 cscope -b -q -I $(srctree)/include -f cscope.out
288 tags:
289 $(RM) -f TAGS tags
290 ls *.c *.h | xargs $(TAGS_PROG) -a
292 # Declare the contents of the .PHONY variable as phony. We keep that
293 # information in a variable so we can use it in if_changed and friends.
294 .PHONY: $(PHONY)
296 # Delete partially updated (corrupted) files on error
297 .DELETE_ON_ERROR:
299 help:
300 @echo 'libbpf common targets:'
301 @echo ' HINT: use "V=1" to enable verbose build'
302 @echo ' all - build libraries and pkgconfig'
303 @echo ' clean - remove all generated files'
304 @echo ' check - check ABI and version info'
305 @echo ''
306 @echo 'libbpf install targets:'
307 @echo ' HINT: use "prefix"(defaults to "/usr/local") or "DESTDIR" (defaults to "/")'
308 @echo ' to adjust target destination, e.g. "make prefix=/usr/local install"'
309 @echo ' install - build and install all headers, libraries and pkgconfig'
310 @echo ' install_headers - install only headers to include/bpf'
311 @echo ''
312 @echo 'libbpf make targets:'
313 @echo ' tags - use ctags to make tag information for source code browsing'
314 @echo ' cscope - use cscope to make interactive source code browsing database'